<?php if(!defined('PLX_ROOT')) EXIT;
class champArt extends plxPlugin {
 public $champId = 'champ'; # nom du param qui procure l'ID du champ (sans numéro)
 public $nbchamp = 0; # total des champs
 public $champgroupe = array(0); # création du tableau des groupes

 public function __construct($default_lang) {
  parent::__construct($default_lang);
  $this->setConfigProfil(PROFIL_ADMIN);
  $this->nbchamp = floor((sizeof($this->aParams))/5); # compte le nombre de ligne
  if(defined('PLX_ADMIN')) {
   $this->addHook('AdminTopEndHead', 'AdminTopEndHead');
   $this->addHook('plxAdminEditArticleXml', 'plxAdminEditArticleXml');
   #AdminArticleContent #applé dans AdminArticleMix
   if ($this->getParam('pos_vie')=='bot'){#choix dans la config
    $this->addHook('AdminArticleContent', 'AdminArticleMix');
   }else if($this->getParam('pos_vie')=='side'){
    $this->addHook('AdminArticleSidebar', 'AdminArticleMix');
   }else if($this->getParam('pos_vie')=='foot'){
    $this->addHook('AdminArticleFoot', 'AdminArticleMix');
   }else{
    $this->addHook('AdminArticleTop', 'AdminArticleMix');
   }
   $this->addHook('champArtAdminHelpContent', 'AdminArticleMix');#shows in help page ;)
  }
  $this->addHook('plxMotorParseArticle', 'plxMotorParseArticle');
  $this->addHook(__CLASS__, __CLASS__);
 }
 public function AdminTopEndHead() { # insère la feuille de style du plugin que dans la page d'édition de l'article
  echo "\t".'<link rel="stylesheet" type="text/css" href="'.PLX_PLUGINS.__CLASS__.'/style.css" media="screen" />'."\n";
 }
 public function AdminArticleMix() {
  $this->init();
  $vPerso = array();
  for($i=1; $i<=$this->nbchamp; $i++) {
   $vPerso[] = __CLASS__.'_'.$this->getId('champ'.$i);#$this->aParams['groupe'.$i]['value'];
  }
  echo '<?php ';?>
   $champArtPersos=explode('|||','<?php echo implode('|||',$vPerso)?>');
   foreach($champArtPersos AS $champArtPerso){
    $$champArtPerso = '';
    if(!empty($_POST)) {
      $$champArtPerso = trim($_POST[$champArtPerso]);
     if(!empty($_POST['preview'])) {
      $art[$champArtPerso] = trim($_POST[$champArtPerso]);
     }
    } elseif(!empty($_GET['a']) && isset($result[$champArtPerso])) {
     $$champArtPerso = trim($result[$champArtPerso]);
    }
   }
?><?php
  $this->AdminArticleContent();
 }
 public function getId($param) {#v1.2.2 : retourne l'id a partir d'une clé (<=1.2.1) clé texte #champ (hook)
  return $this->champId($this->getParam($param));
 }
 public function champId($str) {#v1.2.2 : retourne l'id a partir d'un texte (config, admin, hook)
  return str_replace('-','_',plxUtils::title2url($str));
 }
 public function goodId($champ, $id=false){#v1.2.2 retourne un id unique & valable (scope:config : on teste voir si la balise n'existe pas déjà)
  $s = 0;
  $f = !$this->nbchamp;#false
  while(!$f){
   $f = false;
   for($i=1; $i<=$this->nbchamp; $i++) {#4 this loop
    if($id !== $i) {
     if($this->getId('champ'.$i)==$this->champId($champ)) {
      $s++;
      $champ = $champ.($i+$s+rand(2,9));
      break;
     }
    }
    $f = true;
   }
  }
  return $this->champId($champ);
 }
 public function delParams($save=false) {
  $this->aParams = array();
  if($save) $this->saveParams();
 }
 public function init() {#v1.2.2 : initiz les vars (config, admin, hook help)
  for($i=1; $i<=$this->nbchamp; $i++) {
   $label = $this->aParams['groupe'.$i]['value'];
   if(!empty($label)) :
    array_push($this->champgroupe, $label); # injecte les groupes non vides dans un tableau
   endif;
  }
  $this->champgroupe = array_unique($this->champgroupe); # supprime les groupes en doublons
  $this->champgroupe = array_values($this->champgroupe); # remet les clefs dans un bon ordre
  $this->nbgroupe = sizeof($this->champgroupe); # compte le nombre de groupe unique
 }
 public function AdminArticleContent() {
  echo '<div id="'.__CLASS__.'" class="grid">'.PHP_EOL;
  for($j=1; $j<$this->nbgroupe ; $j++) { # on boucle sur chaque groupe
   echo '<div class="article col sml-12 lrg-6">'.PHP_EOL.'<?php $'.__CLASS__.'_grp_'.$j.' = false; ?>'.PHP_EOL;

   #label
   $legend =
(version_compare(PLX_VERSION,'5.7','>')
 ?#>5.7
   '<input class="toggler" type="checkbox" id="toggler_grp_'.$j.'" />
   <label title="'.$this->getlang('L_MASQUER').' / '.$this->getlang('L_AFFICHER').'" for="toggler_grp_'.$j.'">'.$this->champgroupe[$j].'&nbsp;<span>–</span><span>+</span></label>'
 :#<5.8
   '<legend>'.$this->champgroupe[$j].'&nbsp;'."<a id=\"toggler_grp_".$j."\"
   style=\"outline:none; text-decoration: none;\"
   title=\"".$this->getlang('L_MASQUER')." / ".$this->getlang('L_AFFICHER')."\"
   href=\"javascript:void(0)\"
   onclick=\"toggleDiv('toggle_grp_".$j."', 'toggler_grp_".$j."', '+','–')\">–</a></legend>"
).PHP_EOL;

   #group
   $grp = '<div id="toggle_grp_'.$j.'" class="col sml-12">'.PHP_EOL;
   for($i=1; $i<=$this->nbchamp; $i++) { # on boucle sur chaque ligne
    $cPerso = $this->getId('champ'.$i);#$this->aParams['champ'.$i]['value'];
    if($this->aParams['groupe'.$i]['value']==$this->champgroupe[$j] && !empty($cPerso)){ # si la ligne appartient à ce groupe et que cette ligne n'est pas vide
     $grp .= '<label for="id_'.__CLASS__.'_'.$cPerso.'">'.
     $this->aParams['label'.$i]['value'].' :&nbsp;&nbsp;';
     if(version_compare(PLX_VERSION,'5.7','>')) {#>5.7
      $style = '';
      $grp .= '<?php echo (!empty($'.__CLASS__.'_'.$cPerso.')? "<script>window.document.getElementById(\"toggler_grp_'.$j.'\").checked = true;</script>": ""); ?>'.PHP_EOL;#5.8
      $grp .= '<input class="toggler" type="checkbox" id="toggler_'.$cPerso.'"<?php echo(!empty($'.__CLASS__.'_'.$cPerso.')? " checked": "")?> />
      <label for="toggler_'.$cPerso.'"><span>'.$this->getlang('L_MASQUER').'</span><span>'.$this->getlang('L_AFFICHER').'</span></label>'.PHP_EOL;
     }
     else{#<5.8
      $style = '<?php if(empty($'.__CLASS__.'_'.$cPerso.')){echo " display: none;";}?>';# test si le champ possède une valeur. Si oui > affichage du champ, sinon il reste caché
      $grp .= '<?php echo (!empty($'.__CLASS__.'_'.$cPerso.')? "<script>window.document.getElementById(\"toggle_grp_'.$j.'\").stryle.display = \"\";window.document.getElementById(\"toggler_grp_'.$j.'\").innerHTML = \"–\";</script>": ""); ?>'.PHP_EOL;#<5.8 #untested
      $grp .= "<a id=\"toggler_".$cPerso."\" href=\"javascript:void(0)\"
      onclick=\"toggleDiv('toggle_".$cPerso."', 'toggler_".$cPerso."', '".$this->getlang('L_AFFICHER')."','".$this->getlang('L_MASQUER')."')\">";
      $grp .= '<?php echo (empty($'.__CLASS__.'_'.$cPerso.')? "'.$this->getlang('L_AFFICHER').'": "'.$this->getlang('L_MASQUER').'");?></a>'.PHP_EOL; # test si le champ possède une valeur. Si oui > affichage du champ, sinon il reste caché
     }
     # affichage du champ sous la forme défini
     $grp .= '<div id="toggle_'.$cPerso.'" style="'.$style.'">';
     if($this->aParams['type'.$i]['value']=="ligne"){ # si le champ est de type input ( ligne )
      $grp .= '<?php plxUtils::printInput("'.__CLASS__.'_'.$cPerso.'",plxUtils::strCheck($'.__CLASS__.'_'.$cPerso.'),"text","27-255", false,\'full-width" placeholder="'.plxUtils::strCheck($this->getParam('phold'.$i)).'\'); ?>';
     } else { # sinon c'est un textarea ( bloc )
      $grp .= '<?php plxUtils::printArea("'.__CLASS__.'_'.$cPerso.'",plxUtils::strCheck($'.__CLASS__.'_'.$cPerso.'),"27","5", false,\'full-width" placeholder="'.plxUtils::strCheck($this->getParam('phold'.$i)).'\'); ?>';
     }
     $grp .= '</div>'.PHP_EOL;
     $grp .= '</label>';#5.7 &+?
    }
   }
   $grp .= '</div>'.PHP_EOL;
   echo $legend.$grp;
   echo '</div>'.PHP_EOL;
  }#hcaerof groupes
  echo '</div>'.PHP_EOL;
 }
 public function plxAdminEditArticleXml() {
  echo '<?php '; ?>
  $chmpArt = '<?php echo  __CLASS__?>_';
  $nbchamp = <?php echo $this->nbchamp ?>;
  for($i=1; $i<=$nbchamp; $i++) {
   $cPerso = $this->plxPlugins->aPlugins['<?php echo  __CLASS__?>']->getId('champ'.$i);
   if(!empty($cPerso)) {
    $xml .= "\t".'<'.$chmpArt.$cPerso.'><![CDATA['.plxUtils::cdataCheck(trim($content[$chmpArt.$cPerso])).']]></'.$chmpArt.$cPerso.'>'.PHP_EOL;
   }
  }
?><?php
 }
 public function plxMotorParseArticle() {#var_dump(__CLASS__.'->'.__FUNCTION__.'()');$e = new \Exception;var_dump($e->getTraceAsString());
  echo '<?php '; ?>
  $chmpArt = '<?php echo  __CLASS__?>_';
  $nbchamp = <?php echo $this->nbchamp ?>;
  for($i=1; $i<=$nbchamp; $i++) {
   $cPerso = $this->plxPlugins->aPlugins['<?php echo  __CLASS__?>']->getId('champ'.$i);
   if(!empty($cPerso)){
    if(isset($iTags[$chmpArt.$cPerso][0])){
     $art[$chmpArt.$cPerso] = trim($values[$iTags[$chmpArt.$cPerso][0]]['value']);
    }
   }
  }
?><?php
 }
 public function champArt($param) {
  $plxMotor_inst = plxMotor::getInstance();# permet de récupérer les champs de l'article
  $champ = array();
  for($i=1; $i<=$this->nbchamp; $i++) {
   $cPerso = $this->getId('champ'.$i);#$this->aParams['champ'.$i]['value'];
   if(!empty($cPerso)) :
    array_push($champ, plxUtils::strCheck($cPerso));# on liste les champs non-vides
   endif;
  }

  if(in_array($param, $champ) AND $plxMotor_inst->plxRecord_arts->f(__CLASS__.'_'.$param)) { # si le paramètre fait parti du tableau des valeurs à afficher
   echo $plxMotor_inst->plxRecord_arts->f(''.__CLASS__.'_'.$param); # on affiche la valeur
  } elseif(in_array(substr($param, 0, -2), $champ) AND substr($param, -2)=="_R" AND $plxMotor_inst->plxRecord_arts->f(__CLASS__.'_'.substr($param, 0, -2))) { # si le paramètre fait parti du tableau des valeurs à retourner
   $return = $plxMotor_inst->plxRecord_arts->f(__CLASS__.'_'.substr($param, 0, -2));
   return $return;
  } elseif(in_array(substr($param, 0, -2), $champ) AND substr($param, -2)=="_L" AND $plxMotor_inst->plxRecord_arts->f(__CLASS__.'_'.substr($param, 0, -2))) { # si le paramètre fait parti du tableau des valeurs à retourner
   $this->nbchamp = sizeof($this->aParams)/4;
   for($i=1; $i<=$this->nbchamp; $i++) {
    //~ if ($this->aParams['champ'.$i]['value']==substr($param, 0, -2)){
    if ($this->getId('champ'.$i)==substr($param, 0, -2)){
     echo "<span>".$this->aParams['label'.$i]['value'].":</span> ";
     echo $plxMotor_inst->plxRecord_arts->f(__CLASS__.'_'.substr($param, 0, -2));
    }
   }
  }
  return false;
 }
}