<?php if(!defined('PLX_ROOT')) exit; ?>
<br>
<h2>Aide du plugin champArt</h2>
<h3>Coté rédacteur</h3>
<br>
<p>Rien de plus simple, on suit ce que nous a indiqué l'admin dans l'intitulé. Les données s'enregistrent avec l'article.</p>
<div id="champart">
<fieldset class="article">

<?php
$plxPlugin = $plxAdmin->plxPlugins->aPlugins['champArt'];

	/**
	 * Méthode qui charge le fichier des parametres du plugin parameters.xml
	 *
	 * @return	null
	 * @author	Stephane F
	 */
	function loadHelpParams(&$plug) {

		#if(!is_file($plug->plug['parameters.xml'])) return;

		# Mise en place du parseur XML
		#$data = implode('',file($plug->plug['parameters.xml']));
		$data = implode('',file(__DIR__.'/fr-help.param.xml'));
		var_dump($data);
		$parser = xml_parser_create(PLX_CHARSET);
		xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
		xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,0);
		xml_parse_into_struct($parser,$data,$values,$iTags);
		xml_parser_free($parser);
		# On verifie qu'il existe des tags "parameter"
		if(isset($iTags['parameter'])) {
			# On compte le nombre de tags "parameter"
			$nb = sizeof($iTags['parameter']);
			# On boucle sur $nb
			for($i = 0; $i < $nb; $i++) {
				if(isset($values[$iTags['parameter'][$i]]['attributes']['name'])) {
					$name=$values[$iTags['parameter'][$i]]['attributes']['name'];
					$type=isset($values[$iTags['parameter'][$i]]['attributes']['type'])?$values[$iTags['parameter'][$i]]['attributes']['type']:'numeric';
					$value=isset($values[$iTags['parameter'][$i]]['value'])?$value=$values[$iTags['parameter'][$i]]['value']:'';
/* Cannot access protected property
					$plug->aParams[$name] = array(
						'type'	=> $type,
						'value'	=> $value
					);
*/
					$plug->setParam($name, $value, $type);
				}
			}
		}
	}


    loadHelpParams($plxPlugin);


  //~ $plxPlugin->champgroupe = explode(',','Nom du Groupe,Nom du Groupe 2'); # remet les clefs dans un bon ordre
  //~ $plxPlugin->nbgroupe = sizeof($this->champgroupe); # compte le nombre de groupe unique
   //~ $plxPlugin->addHook('champArtAdminHelpContent', 'AdminArticleMix');

	eval($plxAdmin->plxPlugins->callHook('champArtAdminHelpContent')) # Hook Plugins


?>
<!--
	<parameter name="pos_vie" type="string">side</parameter>
	<parameter name="label1"  type="string">G1</parameter>
	<parameter name="champ1"  type="string">div1</parameter>
	<parameter name="type1"   type="string">ligne</parameter>
	<parameter name="groupe1" type="string">june</parameter>
	<parameter name="label2"  type="string">G2</parameter>
	<parameter name="champ2"  type="string">div2</parameter>
	<parameter name="type2"   type="string">ligne</parameter>
	<parameter name="groupe2" type="string">Divers</parameter>
	<parameter name="label3"  type="string">G3</parameter>
	<parameter name="champ3"  type="string">div</parameter>
	<parameter name="type3"   type="string">ligne</parameter>
	<parameter name="groupe3" type="string">Divers</parameter>


5.6

<legend>Nom du Groupe</legend>
<p><label for="id_champArt_monchamp">Intitulé du champ personalisé:</label>&nbsp;&nbsp;<a id="toggler_monchamp" href="javascript:void(0)" onclick="toggleDiv('toggle_monchamp', 'toggler_monchamp', 'afficher','masquer')">masquer</a>
</p>
<div id="toggle_monchamp" style="display: block; ">
<input id="id_champArt_monchamp" name="champArt_monchamp" type="text" value="Valeur enregistrée dans le champ." size="66" maxlength="255">
</div>

<p><label for="id_champArt_monchamp">ex: "Téléphone portable":</label>&nbsp;&nbsp;<a id="toggler_monchamp2" href="javascript:void(0)" onclick="toggleDiv('toggle_monchamp2', 'toggler_monchamp2', 'afficher','masquer')">masquer</a>
</p>
<div id="toggle_monchamp2" style="display: block; ">
<input id="id_champArt_monchamp" name="champArt_monchamp" type="text" value="écrire ici.." size="66" maxlength="255">
</div>
-->

</fieldset>




<br>
<h3>Cot&eacute; administrateur</h3>
<br>
<p>
Pour afficher sur le site la valeur de votre champ, il faut récupérer la <b>balise</b> du champ depuis l'interface de configuration, puis inc&eacute;rer ce code dans les <i>fichiers du th&egrave;me</i> à l'endroit d&eacute;sir&eacute;:
<blockquote><?php echo htmlentities("<?php eval(\$plxShow->callHook('champArt', 'balise')); ?>"); ?></blockquote>
</p>

<p>
Vous pouvez aussi r&eacute;cup&eacute;rer cette valeur sans l'afficher ( utile pour faire des tests etc ... ), pour cela rajoutez <b>_R</b> &agrave; la fin du param&egrave;tre:
ex: <blockquote><?php echo htmlentities("<?php \$monchamp = \$plxShow->callHook('champArt', 'balise_R'); ?>"); ?></blockquote>
</p>

<p>Un exemple d'application: <i>"si la valeur existe, j'affiche du texte"</i>:
<blockquote>
<?php echo htmlentities("<?php"); ?><br>
<?php echo htmlentities("\$monchamp = \$plxShow->callHook('champArt', 'balise_R');"); ?><br>
<?php echo htmlentities("if(!empty(\$monchamp)) {"); ?><br>
<?php echo htmlentities("echo \"il existe une valeur et elle est égale à: \".\$monchamp;"); ?><br>
<?php echo htmlentities("}"); ?><br>
<?php echo htmlentities("?>"); ?><br>
</blockquote>

<p>
Enfin, si vous souhaitez afficher votre valeur pr&eacute;c&eacute;d&eacute;e de son label, rajoutez <b>_L</b> &agrave; la fin du param&egrave;tre:
ex: <blockquote><?php echo htmlentities("<?php eval(\$plxShow->callHook('champArt', 'balise_L')); ?>"); ?></blockquote>
Cela affichera:
<blockquote>
Intitulé du champ personalisé: Valeur enregistrée dans le champ.
</blockquote>
</p>

</div>